using Expose.MyIT.Shared.Models.Stateless;
using Microsoft.AspNetCore.Mvc;

namespace Expose.MyIT.Server.Controllers;

[ApiController]
[Route("api/[controller]")]
public class ClientSettingsController : ControllerBase, IClientSettingsController<ActionResult>
{

    private readonly IClientSettingsRepository _ClientSettingsRepository;

    public ClientSettingsController(IClientSettingsRepository clientSettingsRepository) => _ClientSettingsRepository = clientSettingsRepository;

    [HttpGet(nameof(IClientSettingsController<ActionResult>.Action.Client))]
    public ActionResult GetClientSettings()
    {
        List<string> results = _ClientSettingsRepository.GetClientSettings(Request.HttpContext.Connection?.RemoteIpAddress);
        return Ok(results);
    }

    [HttpGet(nameof(IClientSettingsController<ActionResult>.Action.IP))]
    public ActionResult GetIpAddress()
    {
        string result = _ClientSettingsRepository.GetIpAddress(Request.HttpContext.Connection?.RemoteIpAddress);
        return Ok(result);
    }

}